//+------------------------------------------------------------------+
//|                            alb - wpr ds jurik on heikin ashi.mq4 |
//|                                                           mladen 
//|                                    2013 mod by Boxter
//|  http://www.forex-tsd.com/advanced-elite/22848-adaptive-lookback-indicators-4.html#post382039
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "www,forex-tsd.com"
#property link      "www,forex-tsd.com"

#property indicator_separate_window
#property indicator_minimum -50
#property indicator_maximum 50

#property indicator_level1  35
#property indicator_level2  0
#property indicator_level3  -35 
#property indicator_levelstyle STYLE_DOT
#property indicator_levelcolor Gold 

#property indicator_buffers 3
#property indicator_color1  PaleVioletRed
#property indicator_width1  2 
#property indicator_color2 Aqua
#property indicator_color3 Magenta

extern int    Length                = 14;
extern double Phase                 = 0;
extern bool   SmoothDouble          = false;
extern int    swingCount            = 5;
extern double speed                 = 1.0;
extern string HA_Info               = "**********Heiken Ashi**********";
extern int    MaPeriod               = 3;
extern int    Step                   = 1;
extern bool   BetterFormula          = true;
extern string mode_info              = "0=MA;1=T3Average;2=Jurik;3=KAMA;4=ALMA;5=albNonLagMA";
extern int    mode                   = 3; 
extern int    MAmethod               = 2; // if mode=0: MODE_SMA 0, MODE_EMA 1, MODE_SMMA 2, MODE_LWMA 3 
extern double T3Hot                  = 0.618;
extern bool   T3Original             = false;
extern double JurikPhase             = 0;
extern int    KAMA_nfast             = 2; 
extern int    KAMA_nslow             = 30;
extern double KAMA_PctFilter         = 0;    // step function
extern double ALMA_Sigma             = 2.0;  //Sigma parameter 
extern double ALMA_Offset            = 0.85; //Offset of Gaussian distribution (0...1)
extern double ALMA_PctFilter         = 1.3;  //Dynamic filter in decimal
extern int    albNonLagMA_swingCount = 5;
extern double albNonLagMA_speed      = 0.3;
extern double albNonLagMA_PctFilter  = 1.3;
extern bool   arrowsVisible    = true;
extern int    TrendMode           =1;

 string arrowsIdentifier = "albWPRarrowsHA";
 color  arrowsUpColor    = MediumSpringGreen;
 color  arrowsDnColor    = Gold;
 double ArrowUpCode =233;
 double ArrowDnCode =234;
 double lowerlevel            = -35.0;
 double upperlevel            = 35.0; 

double wpr[],swingBuffer[],High_HAshi[],Low_HAshi[];
double UpBuffer[];
double DnBuffer[];
double trend[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int init(){
   IndicatorBuffers(7);
   SetIndexBuffer(0,wpr);
   
   SetIndexBuffer(1,UpBuffer);
   SetIndexStyle(1,DRAW_ARROW);
   SetIndexArrow(1,108);  
   SetIndexLabel(1,"UpTrend ");
          
   SetIndexBuffer(2,DnBuffer);
   SetIndexStyle(2,DRAW_ARROW);
   SetIndexArrow(2,108);   
   SetIndexLabel(2,"DownTrend"); 
   
   SetIndexBuffer(3,swingBuffer);
   SetIndexBuffer(4, High_HAshi);
   SetIndexBuffer(5, Low_HAshi);
   SetIndexBuffer(6,trend);
   return(0);
}

int deinit() { 
   string lookFor       = arrowsIdentifier+":";
   int    lookForLength = StringLen(lookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--){
      string objectName = ObjectName(i);
      if (StringSubstr(objectName,0,lookForLength) == lookFor) ObjectDelete(objectName);
   }
   return(0); 
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start(){
   double calcLength = MathSqrt(Length);
   int counted_bars=IndicatorCounted();
   int i,n,k,limit;
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
   limit = MathMin(Bars-counted_bars,Bars-1);

   for (i=limit; i>=0; i--){
      High_HAshi[i]=HAshi("High",i);
      High_HAshi[i+1]=HAshi("High",i+1);
      High_HAshi[i+2]=HAshi("High",i+2);
      High_HAshi[i+3]=HAshi("High",i+3);
      High_HAshi[i+4]=HAshi("High",i+4);
      Low_HAshi[i]=HAshi("Low",i);
      Low_HAshi[i+1]=HAshi("Low",i+1);
      Low_HAshi[i+2]=HAshi("Low",i+2);
      Low_HAshi[i+3]=HAshi("Low",i+3);
      Low_HAshi[i+4]=HAshi("Low",i+4);
                               
      int swing = 0;
      if (High_HAshi[i]>High_HAshi[i+1] && High_HAshi[i+1]>High_HAshi[i+2] && Low_HAshi[i+2] < Low_HAshi[i+3] && Low_HAshi[i+3] < Low_HAshi[i+4]) swing = -1;
      if (Low_HAshi[i] < Low_HAshi[i+1] && Low_HAshi[i+1] < Low_HAshi[i+2] && High_HAshi[i+2]>High_HAshi[i+3] && High_HAshi[i+3]>High_HAshi[i+4]) swing =  1;
      swingBuffer[i] = swing;
      for (k=i,n=0; (k<Bars) && (n<swingCount); k++) if(swingBuffer[k]!=0) n++;
      int WprPeriod = MathMax(MathRound((k-i)/swingCount/speed),1);
      double dClose    = iDSmooth(HAshi("Close",i),                       calcLength,Phase,false,i,0);
      double dMaxHigh  = iDSmooth(HAshi("High",iHighest_HAshi(WprPeriod,i)),calcLength,Phase,false,i,20);
      double dMinLow   = iDSmooth(HAshi("Low",iLowest_HAshi(WprPeriod,i))  ,calcLength,Phase,false,i,40); 
      
 //     Print ("dClose=",dClose,";dMaxHigh=", dMaxHigh,";dMinLow=",dMinLow);  
      wpr[i]   = 50+(-100)*(dMaxHigh - dClose) / (dMaxHigh - dMinLow);
      
      trend[i] = trend[i+1];
      if (TrendMode==1) {
         if (wpr[i] > lowerlevel && wpr[i+1] <= lowerlevel) trend[i] = 1;
         if (wpr[i] < upperlevel && wpr[i+1] >= upperlevel) trend[i] = -1; 
         if (trend[i+1] == 1 && wpr[i] < lowerlevel && wpr[i+1] >= lowerlevel) trend[i] = -1;
         if (trend[i+1] == -1 && wpr[i] > upperlevel && wpr[i+1] <= upperlevel) trend[i] = 1;
         if (wpr[i+1] > lowerlevel && wpr[i+1] < upperlevel && 
             wpr[i] > lowerlevel     && wpr[i] < upperlevel ) {
                if (wpr[i] > 0 && wpr[i+1] <= 0) trend[i] = 1;
                if (wpr[i] < 0 && wpr[i+1] >= 0) trend[i] = -1;
         } 
      }
    
      if (TrendMode==0 || TrendMode >1) {
         if (wpr[i] > lowerlevel && wpr[i+1] <= lowerlevel) trend[i] = 1;
         if (wpr[i] < upperlevel && wpr[i+1] >= upperlevel) trend[i] = -1;    
      }  
      
// Arrows 
      UpBuffer[i] = EMPTY_VALUE;
      DnBuffer[i] = EMPTY_VALUE;     
      if (arrowsVisible == true && trend[i] != trend[i+1]) {
          if (trend[i] == 1)  UpBuffer[i]=lowerlevel; 
          if (trend[i] == -1) DnBuffer[i]=upperlevel; 
          manageArrow(i,trend[i]); 
      }  
   }
   return(0);
}

//+------------------------------------------------------------------+
//|  sub functions
//+------------------------------------------------------------------+
//***********Heiken Ashi functions
double HAshi(string HAmode,int HAshift){
   double HAshi_Open=iCustom(NULL,0,"Heiken_Ashi MA T3 new v2",
                            MaPeriod,Step,BetterFormula,mode_info,mode,
                            MAmethod,T3Hot,T3Original,JurikPhase,KAMA_nfast,KAMA_nslow,KAMA_PctFilter,ALMA_Sigma,
                            ALMA_Offset,ALMA_PctFilter,albNonLagMA_swingCount, 
                            2,HAshift);
   double HAshi_Close=iCustom(NULL,0,"Heiken_Ashi MA T3 new v2",
                            MaPeriod,Step,BetterFormula,mode_info,mode,
                            MAmethod,T3Hot,T3Original,JurikPhase,KAMA_nfast,KAMA_nslow,KAMA_PctFilter,ALMA_Sigma,
                            ALMA_Offset,ALMA_PctFilter,albNonLagMA_swingCount, 
                            3,HAshift);
   if (HAmode=="High" || HAmode=="Low"){                      
      double HAshi_Buf1=iCustom(NULL,0,"Heiken_Ashi MA T3 new v2",
                            MaPeriod,Step,BetterFormula,mode_info,mode,
                            MAmethod,T3Hot,T3Original,JurikPhase,KAMA_nfast,KAMA_nslow,KAMA_PctFilter,ALMA_Sigma,
                            ALMA_Offset,ALMA_PctFilter,albNonLagMA_swingCount, 
                            0,HAshift);
      double HAshi_Buf2=iCustom(NULL,0,"Heiken_Ashi MA T3 new v2",
                            MaPeriod,Step,BetterFormula,mode_info,mode,
                            MAmethod,T3Hot,T3Original,JurikPhase,KAMA_nfast,KAMA_nslow,KAMA_PctFilter,ALMA_Sigma,
                            ALMA_Offset,ALMA_PctFilter,albNonLagMA_swingCount,
                            1,HAshift);       
      double HAshi_Low,HAshi_High;                   
      if (HAshi_Open<HAshi_Close){ HAshi_Low=HAshi_Buf1; HAshi_High=HAshi_Buf2; } 
      else                       { HAshi_Low=HAshi_Buf2; HAshi_High=HAshi_Buf1; } 
   }
//   Print("0 ExtBuf1=",HAshi_Buf1,",ExtBuf2=",HAshi_Buf2,",ExtBuf3=",HAshi_Open,",ExtBuf4=",HAshi_Close);
   if(HAmode=="High")return(HAshi_High);
   if(HAmode=="Low")return(HAshi_Low);
   if(HAmode=="Open")return(HAshi_Open);
   if(HAmode=="Close")return(HAshi_Close);
}                     
                          
int iHighest_HAshi(int WPR_Period,int i){
    double HiMax=HAshi("High",i);
    int j,jmax=i;
    for (j=i+WPR_Period; j>i; j--) {
      double Hjmax=HAshi("High",j);
      if (HiMax<Hjmax) {HiMax=Hjmax;jmax=j;}
    }   
    return (jmax);
}    

int iLowest_HAshi(int WPR_Period, int i){
    double LoMin=HAshi("Low",i);
    int j,jmin=i;
    for (j=i+WPR_Period; j>i; j--)  {
      double Ljmin=HAshi("Low",j);
      if (LoMin>Ljmin) {LoMin=Ljmin;jmin=j;}
    }   
    return (jmin);
} 
 
//***********smooth functions
double wrk[][60];
#define bsmax  5
#define bsmin  6
#define volty  7
#define vsum   8
#define avolty 9

double iDSmooth(double price, double length, double phase,  bool isDouble, int i, int s=0){
   if (isDouble)
         return (iSmooth(iSmooth(price,MathSqrt(length),phase,i,s),MathSqrt(length),phase,i,s+10));
   else  return (iSmooth(iSmooth(price,length,phase,i,s),length,phase,i,s+10));
}

double iSmooth(double price, double length, double phase, int i, int s=0){
   if (length <=1) return(price);
   if (ArrayRange(wrk,0) != Bars) ArrayResize(wrk,Bars);
   int r = Bars-i-1; 
   if (r==0) { for(int k=0; k<7; k++) wrk[r][k+s]=price; for(; k<10; k++) wrk[r][k+s]=0; return(price); }
   double len1   = MathMax(MathLog(MathSqrt(0.5*(length-1)))/MathLog(2.0)+2.0,0);
   double pow1   = MathMax(len1-2.0,0.5);
   double del1   = price - wrk[r-1][bsmax+s];
   double del2   = price - wrk[r-1][bsmin+s];
   double div    = 1.0/(10.0+10.0*(MathMin(MathMax(length-10,0),100))/100);
   int    forBar = MathMin(r,10);
   
	wrk[r][volty+s] = 0;
   if(MathAbs(del1) > MathAbs(del2)) wrk[r][volty+s] = MathAbs(del1); 
   if(MathAbs(del1) < MathAbs(del2)) wrk[r][volty+s] = MathAbs(del2); 
   wrk[r][vsum+s] =	wrk[r-1][vsum+s] + (wrk[r][volty+s]-wrk[r-forBar][volty+s])*div;
   wrk[r][avolty+s] = wrk[r-1][avolty+s]+(2.0/(MathMax(4.0*length,30)+1.0))*(wrk[r][vsum+s]-wrk[r-1][avolty+s]);
   double dVolty;
   if (wrk[r][avolty+s] > 0)            dVolty = wrk[r][volty+s]/wrk[r][avolty+s]; else dVolty = 0;   
	if (dVolty > MathPow(len1,1.0/pow1)) dVolty = MathPow(len1,1.0/pow1);
   if (dVolty < 1)                      dVolty = 1.0;
   double pow2 = MathPow(dVolty, pow1);
   double len2 = MathSqrt(0.5*(length-1))*len1;
   double Kv   = MathPow(len2/(len2+1), MathSqrt(pow2));

   if (del1 > 0) wrk[r][bsmax+s] = price; else wrk[r][bsmax+s] = price - Kv*del1;
   if (del2 < 0) wrk[r][bsmin+s] = price; else wrk[r][bsmin+s] = price - Kv*del2;
	double R     = MathMax(MathMin(phase,100),-100)/100.0 + 1.5;
   double beta  = 0.45*(length-1)/(0.45*(length-1)+2);
   double alpha = MathPow(beta,pow2);

   wrk[r][0+s] = price + alpha*(wrk[r-1][0+s]-price);
   wrk[r][1+s] = (price - wrk[r][0+s])*(1-beta) + beta*wrk[r-1][1+s];
   wrk[r][2+s] = (wrk[r][0+s] + R*wrk[r][1+s]);
   wrk[r][3+s] = (wrk[r][2+s] - wrk[r-1][4+s])*MathPow((1-alpha),2) + MathPow(alpha,2)*wrk[r-1][3+s];
   wrk[r][4+s] = (wrk[r-1][4+s] + wrk[r][3+s]); 
   return(wrk[r][4+s]);
}
//************************ arrow functions

void manageArrow(int i, int trendArr){
   if (arrowsVisible ){
      deleteArrow(Time[i]);
      if (trendArr == 1) drawArrow(i,arrowsUpColor,ArrowUpCode,false); 
      if (trendArr ==-1) drawArrow(i,arrowsDnColor,ArrowDnCode,true);
   }
}               

void drawArrow(int i,color theColor,int ArrowCode,bool up){
   string name = arrowsIdentifier+":"+Time[i];
   double gap  = iATR(NULL,0,20,i);
   ObjectCreate(name,OBJ_ARROW,0,Time[i],0);
   ObjectSet(name,OBJPROP_ARROWCODE,ArrowCode);
   ObjectSet(name,OBJPROP_COLOR,theColor);
   if (up)ObjectSet(name,OBJPROP_PRICE1,High[i]+gap);
   else   ObjectSet(name,OBJPROP_PRICE1,Low[i] -gap);
}

void deleteArrow(datetime time){
   string lookFor = arrowsIdentifier+":"+time; ObjectDelete(lookFor);
}